<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>GMFUCMElementAdapter xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../apidocs/org/eclipse/papyrus/designer/ucm/css/GMFUCMElementAdapter.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2017 CEA LIST and Thales</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher (based on code from Francois Le Fevre)</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.ucm.css;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.LinkedList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EReference;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EStructuralFeature;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.gmf.runtime.notation.BasicCompartment;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.gmf.runtime.notation.DecorationNode;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.gmf.runtime.notation.View;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.ucm.profile.UCMProfile.ucm_components.PortTypeSpec;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.ucm.profile.UCMProfile.ucm_interactions.IPortType;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.gmfdiag.css.dom.GMFElementAdapter;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.gmfdiag.css.engine.ExtendedCSSEngine;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.infra.tools.util.ListHelper;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.diagram.common.stereotype.display.helper.StereotypeDisplayConstant;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.diagram.common.stereotype.display.helper.StereotypeDisplayUtil;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Port;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Stereotype;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.util.UMLUtil;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  <em class="jxr_javadoccomment"> * DOM element adapter for UCM elements</em>
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  <em class="jxr_javadoccomment"> * Supports applied stereotypes and stereotype properties</em>
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../org/eclipse/papyrus/designer/ucm/css/GMFUCMElementAdapter.html">GMFUCMElementAdapter</a> <strong class="jxr_keyword">extends</strong> GMFElementAdapter {
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 * Name of the CSS Simple Selector to match on the Stereotype Compartment Shape</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String STEREOTYPE_COMMENT = <span class="jxr_string">"StereotypeComment"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	<em class="jxr_javadoccomment">/** The stereotype helper. */</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">final</strong> StereotypeDisplayUtil stereotypeHelper = StereotypeDisplayUtil.getInstance();
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  	<em class="jxr_javadoccomment">/** The Constant APPLIED_STEREOTYPES_PROPERTY. */</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String APPLIED_STEREOTYPES_PROPERTY = <span class="jxr_string">"appliedStereotypes"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  	<em class="jxr_javadoccomment">/** The Constant PORT_TYPE. */</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String PORT_TYPE = <span class="jxr_string">"ucmPortType"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  <em class="jxr_javadoccomment">	 * The CSS Separator for qualifiers, when we must use CSS ID</em>
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  <em class="jxr_javadoccomment">	 * When we can use CSS String, we use the standard UML "::" qualifier separator</em>
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  <em class="jxr_javadoccomment">	 * NOTE: Separator "__" does not work</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String QUALIFIER_SEPARATOR = <span class="jxr_string">"--"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../org/eclipse/papyrus/designer/ucm/css/GMFUCMElementAdapter.html">GMFUCMElementAdapter</a>(View view, ExtendedCSSEngine engine) {
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  		<strong class="jxr_keyword">super</strong>(view, engine);
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  		helper = CSSDOMUCMSemanticElementHelper.getInstance();
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  	}
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  <em class="jxr_javadoccomment">	 * {@inheritDoc}</em>
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  <em class="jxr_javadoccomment">	 * Applied Stereotypes are manipulated as DOM Attributes</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  	@Override
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  	<strong class="jxr_keyword">protected</strong> String doGetAttribute(String attr) {
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  		String parentValue = <strong class="jxr_keyword">super</strong>.doGetAttribute(attr);
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  		<strong class="jxr_keyword">if</strong> (parentValue != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  			<strong class="jxr_keyword">return</strong> parentValue;
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  		}
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		<em class="jxr_comment">// get stereotype Label attribute</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  		<strong class="jxr_keyword">if</strong> (stereotypeHelper.isStereotypeLabel(semanticElement)) {
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  			String value = getStereotypeLabelAttribute(attr);
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  			<strong class="jxr_keyword">if</strong> (value != <strong class="jxr_keyword">null</strong> &amp;&amp; !value.isEmpty()) {
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  				<strong class="jxr_keyword">return</strong> value;
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  			}
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  		}
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  		<em class="jxr_comment">// get stereotype Compartment attribute</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 		<strong class="jxr_keyword">if</strong> (stereotypeHelper.isStereotypeCompartment(semanticElement) || stereotypeHelper.isStereotypeBrace(semanticElement)) {
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 			String value = getStereotypeCompartmentAttribute(attr);
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 			<strong class="jxr_keyword">if</strong> (value != <strong class="jxr_keyword">null</strong> &amp;&amp; !value.isEmpty()) {
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 				<strong class="jxr_keyword">return</strong> value;
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 			}
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		}
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 		<em class="jxr_comment">// get stereotype Property attribute</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 		<strong class="jxr_keyword">if</strong> (stereotypeHelper.isStereotypeProperty(semanticElement) || stereotypeHelper.isStereotypeBraceProperty(semanticElement)) {
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 			String value = getStereotypePropertyAttribute(attr);
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 			<strong class="jxr_keyword">if</strong> (value != <strong class="jxr_keyword">null</strong> &amp;&amp; !value.isEmpty()) {
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 				<strong class="jxr_keyword">return</strong> value;
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 			}
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		}
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		<strong class="jxr_keyword">if</strong> (semanticElement instanceof Element) {
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 			<em class="jxr_comment">// Applied stereotypes</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 			Element currentElement = (Element) semanticElement;
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 			<em class="jxr_comment">// Get applied STereotypes Attributes</em>
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 			<strong class="jxr_keyword">if</strong> (APPLIED_STEREOTYPES_PROPERTY.equals(attr)) {
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 				List&lt;String&gt; appliedStereotypes = <strong class="jxr_keyword">new</strong> LinkedList&lt;String&gt;();
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 				<strong class="jxr_keyword">for</strong> (Stereotype stereotype : currentElement.getAppliedStereotypes()) {
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 					appliedStereotypes.add(stereotype.getName());
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 					appliedStereotypes.add(stereotype.getQualifiedName());
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 				}
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 				<strong class="jxr_keyword">if</strong> (!appliedStereotypes.isEmpty()) {
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 					<strong class="jxr_keyword">return</strong> ListHelper.deepToString(appliedStereotypes, CSS_VALUES_SEPARATOR);
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 				}
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 			}
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 			<strong class="jxr_keyword">for</strong> (EObject stereotypeApplication : currentElement.getStereotypeApplications()) {
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 				EStructuralFeature feature = stereotypeApplication.eClass().getEStructuralFeature(attr);
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 				<strong class="jxr_keyword">if</strong> (feature != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 					<strong class="jxr_keyword">if</strong> (feature.isMany()) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 						List&lt;?&gt; values = (List&lt;?&gt;) stereotypeApplication.eGet(feature);
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 						List&lt;String&gt; cssValues = <strong class="jxr_keyword">new</strong> LinkedList&lt;String&gt;();
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 						<strong class="jxr_keyword">for</strong> (Object value : values) {
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 							cssValues.add(getCSSValue(feature, value));
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 						}
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 						<strong class="jxr_keyword">return</strong> ListHelper.deepToString(cssValues, CSS_VALUES_SEPARATOR);
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 					} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 						Object value = stereotypeApplication.eGet(feature);
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 						<strong class="jxr_keyword">return</strong> getCSSValue(feature, value);
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 					}
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 				}
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 			}
<a class="jxr_linenumber" name="L147" href="#L147">147</a> 
<a class="jxr_linenumber" name="L148" href="#L148">148</a> 			<strong class="jxr_keyword">if</strong> (attr.contains(QUALIFIER_SEPARATOR)) {
<a class="jxr_linenumber" name="L149" href="#L149">149</a> 				List&lt;String&gt; qualifiers = ListHelper.asList(attr.split(QUALIFIER_SEPARATOR)); <em class="jxr_comment">// Writable list</em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 				String propertyName = qualifiers.remove(qualifiers.size() - 1); <em class="jxr_comment">// Last element is the property name</em>
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 				<em class="jxr_comment">// Remaining strings can be used to build the Stereotype's qualified name</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 				String stereotypeName = ListHelper.deepToString(qualifiers, <span class="jxr_string">"::"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 				Stereotype appliedStereotype = currentElement.getAppliedStereotype(stereotypeName);
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 				<strong class="jxr_keyword">if</strong> (appliedStereotype != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 					EObject stereotypeApplication = currentElement.getStereotypeApplication(appliedStereotype);
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 					EStructuralFeature feature = stereotypeApplication.eClass().getEStructuralFeature(propertyName);
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 					<strong class="jxr_keyword">if</strong> (feature != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 						Object value = stereotypeApplication.eGet(feature);
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 						<strong class="jxr_keyword">return</strong> getCSSValue(feature, value);
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 					}
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 				}
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 			}
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 			<em class="jxr_comment">// manage of isReference=true attribute for Property</em>
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 			<strong class="jxr_keyword">if</strong> (semanticElement instanceof Port) {
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 				<strong class="jxr_keyword">if</strong> (PORT_TYPE.equals(attr)) {
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 					Type type = ((Port) semanticElement).getType();
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 					<strong class="jxr_keyword">if</strong> (type != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 						PortTypeSpec spec = UMLUtil.getStereotypeApplication(type, PortTypeSpec.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 						<strong class="jxr_keyword">if</strong> (spec != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 							IPortType templateType = spec.getType();
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 							<strong class="jxr_keyword">if</strong> (templateType != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 								<strong class="jxr_keyword">return</strong> templateType.getBase_Class().getName();	
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 							}
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 						}
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 					}
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 				}
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 			}
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 		}
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 	}
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L184" href="#L184">184</a> <em class="jxr_javadoccomment">	 * Retrieve the Matching String Value for the StereotypeCompartment Element</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L186" href="#L186">186</a> <em class="jxr_javadoccomment">	 * @param attr</em>
<a class="jxr_linenumber" name="L187" href="#L187">187</a> <em class="jxr_javadoccomment">	 *            Attribute of the String to match with</em>
<a class="jxr_linenumber" name="L188" href="#L188">188</a> <em class="jxr_javadoccomment">	 * @return The matching value for this Attribute</em>
<a class="jxr_linenumber" name="L189" href="#L189">189</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 	<strong class="jxr_keyword">protected</strong> String getStereotypeCompartmentAttribute(String attr) {
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 		<strong class="jxr_keyword">if</strong> (StereotypeDisplayConstant.STEREOTYPE_COMPARTMENT_NAME.equals(attr)) {
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 			BasicCompartment propertyCompartment = (BasicCompartment) semanticElement;
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 			<strong class="jxr_keyword">return</strong> stereotypeHelper.getName(propertyCompartment);
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 		}
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 		<strong class="jxr_keyword">return</strong> <span class="jxr_string">""</span>;<em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 	}
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L201" href="#L201">201</a> <em class="jxr_javadoccomment">	 * Retrieve the Matching String Value for the StereotypeCompartment Element</em>
<a class="jxr_linenumber" name="L202" href="#L202">202</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> <em class="jxr_javadoccomment">	 * @param attr</em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> <em class="jxr_javadoccomment">	 *            Attribute of the String to match with</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> <em class="jxr_javadoccomment">	 * @return The matching value for this Attribute</em>
<a class="jxr_linenumber" name="L206" href="#L206">206</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 	<strong class="jxr_keyword">protected</strong> String getStereotypePropertyAttribute(String attr) {
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 		<em class="jxr_comment">// CSS can match property level</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 		<strong class="jxr_keyword">if</strong> (StereotypeDisplayConstant.STEREOTYPE_PROPERTY_NAME.equals(attr)) {
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 			DecorationNode propertyLabel = (DecorationNode) semanticElement;
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 			<strong class="jxr_keyword">if</strong> (propertyLabel.getElement() instanceof Property) {
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 				Property prop = (Property) propertyLabel.getElement();
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 				<strong class="jxr_keyword">return</strong> prop.getName();
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 			}
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 			<em class="jxr_comment">// CSS can match Container Name</em>
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 		} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (StereotypeDisplayConstant.STEREOTYPE_COMPARTMENT_NAME.equals(attr)) {
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 			EObject propertyCompartment = ((DecorationNode) semanticElement).eContainer();
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 			<strong class="jxr_keyword">if</strong> (stereotypeHelper.isStereotypeCompartment(propertyCompartment)) {
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 				<strong class="jxr_keyword">return</strong> stereotypeHelper.getName((DecorationNode) propertyCompartment);
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 			}
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 		}
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 		<strong class="jxr_keyword">return</strong> <span class="jxr_string">""</span>;<em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 	}
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L231" href="#L231">231</a> <em class="jxr_javadoccomment">	 * Get the matching Value of the Attribute</em>
<a class="jxr_linenumber" name="L232" href="#L232">232</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L233" href="#L233">233</a> <em class="jxr_javadoccomment">	 * @param attr</em>
<a class="jxr_linenumber" name="L234" href="#L234">234</a> <em class="jxr_javadoccomment">	 *            Attribute of the String to match with</em>
<a class="jxr_linenumber" name="L235" href="#L235">235</a> <em class="jxr_javadoccomment">	 * @return The matching value for this Attribute</em>
<a class="jxr_linenumber" name="L236" href="#L236">236</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 	<strong class="jxr_keyword">protected</strong> String getStereotypeLabelAttribute(String attr) {
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 		<strong class="jxr_keyword">if</strong> (StereotypeDisplayConstant.STEREOTYPE_LABEL_NAME.equals(attr)) {
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 			DecorationNode label = (DecorationNode) semanticElement;
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 			<strong class="jxr_keyword">return</strong> stereotypeHelper.getName(label);
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 		}
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 
<a class="jxr_linenumber" name="L244" href="#L244">244</a> 		<strong class="jxr_keyword">if</strong> (KIND.equals(attr) &amp;&amp; stereotypeHelper.isStereotypeLabel(semanticElement)) {
<a class="jxr_linenumber" name="L245" href="#L245">245</a> 			<strong class="jxr_keyword">return</strong> StereotypeDisplayConstant.STEREOTYPE_LABEL_TYPE;
<a class="jxr_linenumber" name="L246" href="#L246">246</a> 		}
<a class="jxr_linenumber" name="L247" href="#L247">247</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L248" href="#L248">248</a> 	}
<a class="jxr_linenumber" name="L249" href="#L249">249</a> 
<a class="jxr_linenumber" name="L250" href="#L250">250</a> 	@Override
<a class="jxr_linenumber" name="L251" href="#L251">251</a> 	<strong class="jxr_keyword">protected</strong> String getCSSValue(EStructuralFeature feature, Object value) {
<a class="jxr_linenumber" name="L252" href="#L252">252</a> 		<strong class="jxr_keyword">if</strong> (feature instanceof EReference &amp;&amp; value instanceof NamedElement) {
<a class="jxr_linenumber" name="L253" href="#L253">253</a> 			String name = ((NamedElement) value).getName();
<a class="jxr_linenumber" name="L254" href="#L254">254</a> 			<strong class="jxr_keyword">return</strong> name == <strong class="jxr_keyword">null</strong> || name.isEmpty() ? EMPTY_VALUE : name; <em class="jxr_comment">// Bug 467716: Never return null or empty string if the value is not null</em>
<a class="jxr_linenumber" name="L255" href="#L255">255</a> 		}
<a class="jxr_linenumber" name="L256" href="#L256">256</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">super</strong>.getCSSValue(feature, value);
<a class="jxr_linenumber" name="L257" href="#L257">257</a> 	}
<a class="jxr_linenumber" name="L258" href="#L258">258</a> 
<a class="jxr_linenumber" name="L259" href="#L259">259</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L260" href="#L260">260</a> <em class="jxr_javadoccomment">	 * @see org.eclipse.papyrus.infra.gmfdiag.css.dom.GMFElementAdapter#getLocalName()</em>
<a class="jxr_linenumber" name="L261" href="#L261">261</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L262" href="#L262">262</a> <em class="jxr_javadoccomment">	 * @return The Local name for the CSS matching.</em>
<a class="jxr_linenumber" name="L263" href="#L263">263</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L264" href="#L264">264</a> 	@Override
<a class="jxr_linenumber" name="L265" href="#L265">265</a> 	<strong class="jxr_keyword">public</strong> String getLocalName() {
<a class="jxr_linenumber" name="L266" href="#L266">266</a> 		<em class="jxr_comment">// In case of StereotypeComment type, the selector should match on the Stereotype Comment.</em>
<a class="jxr_linenumber" name="L267" href="#L267">267</a> 		<strong class="jxr_keyword">if</strong> (localName == <strong class="jxr_keyword">null</strong> &amp;&amp; stereotypeHelper.isStereotypeComment(getNotationElement())) {
<a class="jxr_linenumber" name="L268" href="#L268">268</a> 			<strong class="jxr_keyword">return</strong> STEREOTYPE_COMMENT;
<a class="jxr_linenumber" name="L269" href="#L269">269</a> 		}
<a class="jxr_linenumber" name="L270" href="#L270">270</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">super</strong>.getLocalName();
<a class="jxr_linenumber" name="L271" href="#L271">271</a> 	}
<a class="jxr_linenumber" name="L272" href="#L272">272</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
